package terminal;

import static terminal.SelectGraphicRendition.SGR_COMMAND;

import java.util.*;

import terminal.ControlSequence.NullControlSequence;

public class ControlSequenceLookup {

    private static Map<Character, Map<String, ControlSequence>> controlSequenceMap = new HashMap<>();

    static {
        Map<String, ControlSequence> selectGraphicRenditionMap = new HashMap<>();

        for (SelectGraphicRendition sgr : SelectGraphicRendition.values())
            selectGraphicRenditionMap.put(sgr.getCode(), sgr);

        controlSequenceMap.put(SGR_COMMAND, selectGraphicRenditionMap);
    }

    public static ControlSequence lookupControlSequence(char command, String code) {
        Map<String, ControlSequence> commandMap = controlSequenceMap.getOrDefault(command, new HashMap<>());

        return commandMap.getOrDefault(code, new NullControlSequence());
    }

}